/*
 * tfidfsw.c
 *
 * Copyright (c) 1998-2001,2002 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * ʸФΤʸ׻
 *
 * ϤϷǲϷ̤ˤ롥 
 * chasen 2.2.x     -e  
 * juman  3.61      -e
 * KNP              -tab   б
 *
 * ʸγƸνŤߤtf or tfidfǷ׻­礻롥
 * Query biased б
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <chainers/patrash.h>
#include <chainers/nero.h>
/*#include "cmn.h"*/
#include <chainers/mrpfil.h>
#include "tfflt.h"
#include "qbnrm.h"

extern struct patrash_files* patrash_preparation ();
extern struct patrash_answer_int* tell_patrash_int ();

extern int         chaflt_out_num;
extern int         number_of_words;

extern void sscalcmore();
extern int get_tf_from_hash();
extern CHAFLT_OUT* indirect_chaflt ();

/* static int filtermode;*/
/* static int mrp_type; */
static int qb; /* query biased */
static double qwgt; /* query baised wegiht */
/* char *mrf; */

static char *pname;
static int  weight_mode;/* ñνŤդ⡼ 0:no 1:tf 2:tfidf */
static char *dffile;	/* dffile ̾ */
static char *qffile;	/* query file ̾ */
int N;

static int  norm_mode;	/* ʸĹˤ⡼ */
static double norm_val;	/* Ψ? */

#ifndef HashSize
#define HashSize 1001
#endif

static help()
{
	fprintf (stderr, "Posum version 1.50 -tfidfsw-");
	fprintf (stderr, "   (c) motizuki@jaist.ac.jp\n");
	fprintf (stderr, "usage: %s [options] < morphfile\n", pname);
	fprintf (stderr, "\n");
	fprintf (stderr, "INPUT TYPE\n");
	fprintf (stderr, "  -knp     : KNP -tab Ϥ\n");
	fprintf (stderr, "  -cha     : ChaSen 2.2.x  -e Ϥ(default)\n");
	fprintf (stderr, "  -jum     : Juman3.61     -e Ϥ\n");
	fprintf (stderr, "FILTER FILE\n");
	fprintf (stderr, "  -rule <filename> : ñꥹȤʤɤ򵭽Ҥfileλ\n");
	fprintf (stderr, "TERM SELECTION\n");
        fprintf (stderr, "  -F <num> :filter mode θʻλ Default=0\n");
        fprintf (stderr, "\t\t 0 . ̾ ư ƻ\n");
        fprintf (stderr, "\t\t 1 . ̾ ---- ƻ\n");
        fprintf (stderr, "\t\t 2 . ̾ ---- ------\n");
        fprintf (stderr, "\t\t 3 . ̾ ư ------\n");
        fprintf (stderr, "\t\t 4 . ---- ư ------\n");
        fprintf (stderr, "\t\t 5 . ---- ư ƻ\n");
        fprintf (stderr, "\t\t 6 . ---- ---- ƻ\n");
	fprintf (stderr, "WEIGHTING TYPE\n");
	fprintf (stderr, "  -twm <num> :ñνŤդ⡼ɻ Default=1\n");
	fprintf (stderr, "\t\t0   : Ťդʤ\n");
	fprintf (stderr, "\t\t1   : Ťդ tf\n");
	fprintf (stderr, "\t\t2   : Ťդ tfidf (dffileɬ)\n");
	fprintf (stderr, "  -df <filename> :ŤդΤdffile\n");
	fprintf (stderr, "QUERY-BIASED\n");
	fprintf (stderr, "  -qf <filename> :query biasedΤΥե\n");
	fprintf (stderr, "  -qwgt <num> :query biasedΤνŤߤ Default=3\n");
	fprintf (stderr, "NORMALIZATION\n");
	fprintf (stderr, "  -nm <num> :ʸĹˤ⡼ɻ Default=0\n");
	fprintf (stderr, "\t\t0 : ʤ\n");
	fprintf (stderr, "\t\t1 : ñ\n");
	fprintf (stderr, "\t\t2 : ʸкͤ\n");
	fprintf (stderr, "\t\t3 : ʸΥ2/ñ\n");
	fprintf (stderr, "\t\t4 : ñ*-nm_val \n");
	fprintf (stderr, "\t\t5 : (ñǳ/2)+(ʸкͤǳ)\n");
	fprintf (stderr, "  -nm_val <num> :-nm 4λνŤ Default=1\n");
	fprintf (stderr, "  -h  :help\n");
	fprintf (stderr, "\n");
	exit(1);
}

void optchk (argc, argv)
       int   argc;
       char *argv[];
{
	pname = argv[0];
	filtermode = 0;
	weight_mode = 1;
	mrf = NULL; /* rule fileλ꤬Ф */
	qb = 0;
	norm_mode = 0;
	norm_val = (double)1;
	qwgt=(double)3;
	mrp_type  = 0; /* 0=ChaSen2.2.x, 1=KNP, 2=Juman*/

	argc--, argv++;

	while (argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-df")) {
			argc--, argv++;
			dffile = argv[0];
			weight_mode = 2;
		} else if (!strcmp(argv[0], "-F")) {
			argc--, argv++;
			filtermode=atoi(argv[0]);
		} else if (!strcmp(argv[0], "-twm")) {
			argc--, argv++;
			weight_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-nm")) {
			argc--, argv++;
			norm_mode=atoi(argv[0]);
		} else if (!strcmp(argv[0], "-nm_val")) {
			argc--, argv++;
			norm_val = atof(argv[0]);
		} else if (!strcmp(argv[0], "-qf")) {
			argc--, argv++;
			qffile = argv[0];
			qb=1;
		} else if (!strcmp(argv[0], "-qwgt")) {
			argc--, argv++;
			qwgt=atof(argv[0]);
		} else if (!strcmp(argv[0], "-knp")) {
			mrp_type = 1;
		} else if (!strcmp(argv[0], "-cha")) {
			mrp_type = 0;
		} else if (!strcmp(argv[0], "-jum")) {
			mrp_type = 2;
		} else if (!strcmp(argv[0], "-rule")) {
			argc--, argv++;
			mrf = argv[0];
		} else if (!strcmp(argv[0], "-h")) {
			help();
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
		}
		argc--, argv++;
	}
}

int main (argc, argv)
    int   argc;
    char *argv[];
{
	int  ct, sn, wn, pwn, realwn, entry, hashsize=HashSize;
	int i, j, tf, df, qentry, qhashsize=HashSize, qtf, sct, awwct;
	double qval;
	struct sentence *ss, *tp;
	char *cptr, buf[BUFSIZ], QWD[100], QTF[20];
	struct tmpwords *tw, *tmp;
	CHAFLT_OUT *words;
	struct hash_entry *hashtab[HashSize];
	struct patrash_files *pf;
	struct patrash_answer_int *intr;
	FILE *qfile;
	struct hash_entry *qhashtab[HashSize];

	optchk(argc, argv);

	sn=wn=realwn=1; /* ʸֹ桤ֹ1Ϥޤ */
	chaflt_out_num=0;/* indirect_chafltȤˤɬ */

	if ((tw=calloc((size_t)30, sizeof(*tw)))==NULL) {
		perror ("calloc for tw");
		exit(1);
	}
	if ((ss=calloc((size_t)31, sizeof(*ss)))==NULL) {
		perror("calloc for ss");
		exit(1);
	}
	sct=31, j=1;
	ct = 30;
	N=0;
	if (weight_mode==2) {
		if (dffile==NULL) help();
		pf = patrash_preparation (dffile);
		intr  = tell_patrash_int ("N", pf->pa, pf->wan);
		if (intr==NULL) {
			fprintf (stderr, "??? dffile is broken??\n");
			exit(1);
		}
		N = intr->num;
		free(intr); intr=NULL;
	}

	if (qb==1) {
		if (qffile==NULL) help();
		if ((qfile=fopen(qffile, "r"))==NULL) {
			fprintf (stderr, "cannot open %s\n", qffile);
			exit(1);
		}
		init_hash_f (qhashtab, qhashsize); 
		qentry = 0;
		while (fgets(buf, BUFSIZ, qfile)!=NULL) {
			sscanf(buf, "%s %s\n", QWD, QTF);
			qentry+=hash_update(QWD, QTF, qhashtab, qhashsize);
		}
		fclose(qfile);
	}
	sn = 0;
	i=1, awwct=0;
	init_hash_f (hashtab, hashsize); 
	while (fgets(buf, BUFSIZ, stdin)!=NULL) {
		buf[strlen(buf)-1]='\0'; 		/* \n  */
		/* EOSjuman,chasenòƤޤŶ */
		if (strcmp(buf, "EOS")==0) { /*ʸѤä*/
			if (i>=sct) {
				if ((tp=realloc(ss, 
						sizeof(*ss)*(sct+10)))==NULL){
					perror ("malloc for ss");
					exit(1);
				}
				ss=tp;
				sct+=10;
			}
			ss[i].sn = i;
			ss[i].wnum = chaflt_out_num;
			awwct+= ss[i].wnum;
			i++;
			if (sn>=ct) {
				if ((tmp=
				     realloc(tw, sizeof(*tw)*(ct+10)))==
				    NULL) {
					perror ("realloc for tw");
					exit(1);
				}
				tw=tmp;
				ct+=10;
			}
			if (chaflt_out_num>0) {
				entry += tffilter (words, hashtab, hashsize);
				copy_words (tw, words, sn);
				/* indirect_chafltȤˤɬ */
				chaflt_out_num=0;
			} else {
				tw[sn].ct=chaflt_out_num;
			}
			sn++;/* ʸֹ 1䤹*/
			wn=1;/* ֹ Ͻ */
			realwn=1;
		} else if (mrp_type==1 &&  /* KNP -tab */
			    ((buf[0] == '#' && buf[1] == ' ' &&
			      buf[2] == 'S') ||
			     (buf[0] == '*' && buf[1] == ' ')
			     ||
			     (buf[0] == ';' && buf[1] == ';'))) {
			;
		} else {
			pwn=wn;
			/*ͭñ*/
			words=indirect_chaflt(buf,sn,&wn,filtermode,realwn,mrp_type,mrf);
			realwn++;
			/*
			if (ciw_sw==1 && pwn==wn) wn++;
			*/
		}
	}

	for (i=0; i<sn; i++) {
		ss[(i+1)].scr=(double)0;
		for (j=0; j<tw[i].ct; j++) {
			tf = get_tf_from_hash(tw[i].word[j], hashtab, hashsize);
			qval=(double)1;
			if (qb==1) {
				qtf = get_tf_from_hash(tw[i].word[j], qhashtab, qhashsize);
				if (qtf>0) {
					qval=qwgt;
				}
			}

			switch (weight_mode) {
			case 0:
				ss[(i+1)].scr+=(double)1*(double)qval;
				break;
			case 1:
				ss[(i+1)].scr += (double)tf*(double)qval;
				break;
			   case 2:
				intr=tell_patrash_int(tw[i].word[j],
						      pf->pa,pf->wan);
				df = 1;
				if (intr!=NULL) {
					if (df < intr->num) {
						df = intr->num;
					}
					free(intr); intr=NULL;
				}
				ss[(i+1)].scr += (double)qval * 
					(double)tf * log((double)N/(double)df);
				break;
			}
		}
		/* printf ("%d %f\n", i+1, ss[(i+1)].scr);*/
	}
	sscalcmore(ss, sn, awwct, norm_mode, norm_val);
}
