/*
 * extsent.c
 *
 * Copyright (c) 2000,2001,2002 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <chainers/mrpfil.h>
/*#include "cmn.h"*/
#include "qbnrm.h"

extern int         chaflt_out_num;
extern int         number_of_words;
extern CHAFLT_OUT* direct_chaflt ();
extern char*       chasen_sparse_tostr ();

static char *pname;
static int  ttl;	/* ƬʸϼưŪ˽ */
static int sum_mode;	/* ⡼ */
static double sum_val;  /* Ψ */
static char *fname;
static int form_mode; 	/* ɽ⡼ */
static int debug;

static help()
{
	fprintf (stderr, "Posum version 1.50 -extsents- (c) Hajime Mochizuki\n");
	fprintf (stderr, "usage: %s [options] Original_Text < sscr_file\n", pname);
	fprintf (stderr, "fname=txtfile\n");
	fprintf (stderr, "\t[-ttl #] Ƭ x ʸ̵\n");
	fprintf (stderr, "\t[-sum_mode #] ϥ⡼ɻ\n");
	fprintf (stderr, "\t\t0 : ʸ-sum_valʸ\n");
	fprintf (stderr, "\t\t1 : ʸ  * -sum_valʸ default\n");
	fprintf (stderr, "\t[-sum_val #] ʸ (0.3)\n");
	fprintf (stderr, "\t[-form_mode #] ɽη\n");
	fprintf (stderr, "\t\t0 : ʸ defalut\n");
	fprintf (stderr, "\t\t1 :  ʸ\n");
	fprintf (stderr, "\t\t2 : ʸֹ ʸ\n");
	fprintf (stderr, "\t\t3 : ʸֹ \n");
	fprintf (stderr, "\t\t4 : \n");
	fprintf (stderr, "\t\t5 : ʸֹ\n");
	fprintf (stderr, "\t[-D] debug mode\n");
	fprintf (stderr, "\n");
	exit(1);
}

void optck (argc, argv)
    int   argc;
    char *argv[];
{
	pname = argv[0];
	argc--, argv++;
	if (argc<1) {
		help();
	}
	ttl = 0;
	sum_mode = 1;
	sum_val = (double)0.3;
	form_mode = 0;
	debug=0;
	while(argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-ttl")) {
			argc--, argv++;
			ttl = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-sum_mode")) {
			argc--, argv++;
			sum_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-sum_val")) {
			argc--, argv++;
			sum_val = atof(argv[0]);
		} else if (!strcmp(argv[0], "-form_mode")) {
			argc--, argv++;
			form_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-D")) {
			debug=1;
		} else if (!strcmp(argv[0], "-h")) {
			help();
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
		}
		argc--, argv++;
	}
	fname = argv[0];
}
		
int calc_out_snum (mode, val, snum)
    int mode;
    double val;
    int snum;
{
	int outnum;
	double diff;

	outnum = 0;
	switch (mode)
	{
	   case 0:
		outnum = (int)val;
		break;
	   case 1:
		outnum = (int)snum*val;
		diff = (snum*val) - (double)outnum;
		if (diff>=(double)0.5) {
			outnum++;
		}
		break;
	}
	if (outnum < 1) outnum = 1;
	if (outnum > snum) outnum=snum;
	return outnum;
}

/* scoreǥ */
void sssort(f, l, a)
    int f, l;
    struct sentence a[];
{
	int i, j;
	double x;
	struct sentence s;

	x = a[((f+l)/2)].scr;
	i=f, j=l;
	for (;;) {
		while (a[i].scr>x) i++;
		while (x>a[j].scr) j--;
		if (i>=j) break;
		s=a[i];
		a[i]=a[j];
		a[j]=s;
		i++,j--;
	}
	if (f<i-1) sssort(f,i-1,a);
	if (j+1<l) sssort(j+1,l,a);
}

/* snǥ */
void snsort(f, l, a)
    int f, l;
    struct sentence a[];
{
	int i, j, x;
	struct sentence s;

	x = a[((f+l)/2)].sn;
	i=f, j=l;
	for (;;) {
		while (a[i].sn<x) i++;
		while (x<a[j].sn) j--;
		if (i>=j) break;
		s=a[i];
		a[i]=a[j];
		a[j]=s;
		i++,j--;
	}
	if (f<i-1) snsort(f,i-1,a);
	if (j+1<l) snsort(j+1,l,a);
}

void selects(ss, sn, outsn, ttl, fmode)
    struct sentence *ss;
    int  outsn, ttl;
    int  fmode;
{
	int i, j, outct;

	outct=0;
	if(debug) fprintf(stderr, "outsn=%d outct=%d\n", outsn, outct);
	if ((outsn-ttl)>0) {
		sssort(ttl+1, sn, ss);	/* Ƭʬƥsort */
		if(debug) {
			for(i=1; i<=sn; i++) {
				fprintf(stderr, "%d %f %s", ss[i].sn, 
					ss[i].scr, ss[i].body);
			}
		}
		snsort(ttl+1, outsn, ss); /*Ƭʬʬsnsort*/
		if (debug) {
			fprintf (stderr, "\n");
			for(j=1;j<outsn; j++) {
				fprintf (stderr, "%d %d\n", j, ss[j].sn);
			}
		}
	}
	for (j=1; j<=outsn; j++) {
		switch (fmode)
		{
		   case 0:
		   default:
			printf ("%s", ss[j].body);
			break;
		   case 1:
			printf ("%f %s", ss[j].scr, ss[j].body);
			break;
		   case 2:
			printf ("%d %s", ss[j].sn, ss[j].body);
			break;
		   case 3:
			printf ("%d %f %s", ss[j].sn, ss[j].scr, 
				ss[j].body);
			break;
		   case 4:
			printf ("%f\n", ss[j].scr);
			break;
		   case 5:
			printf ("%d\n", ss[j].sn);
			break;
		}
	}
}

int main (argc, argv)
    int   argc;
    char *argv[];
{
	int  sct, i, j, k, sn, outsn;
	char buf[BUFSIZ], buf2[BUFSIZ], word[2][60], *cptr;
	struct sentence *ss, *tp;
	FILE *f;
	CHAFLT_OUT *words;

	optck (argc, argv);
	/*
	chasen_preparation (pname);
	*/

	if ((f=fopen(fname, "r"))==NULL) {
		fprintf (stderr, "cannot open %s\n", fname);
		exit(1);
	}

	if ((ss=calloc((size_t)31, sizeof(*ss)))==NULL) {
		perror("calloc for ss");
		exit(1);
	}
	sct=31, j=1;
	/* ʸɤ߹ */
	while(fgets(buf, BUFSIZ, stdin)!=NULL) {
		buf[strlen(buf)-1]='\0';
		for (i=0; buf[0]!='\0'; i++) {
			word[i][0]='\0';
			splitdata (word[i], buf, ' ');
		}
		if (j>=sct) {
			if ((tp=realloc(ss, sizeof(*ss)*(sct+10)))==NULL) {
				perror ("malloc for ss");
				exit(1);
			}
			ss=tp;
			sct+=10;
		}
		ss[j].sn = j;
		ss[j].scr=atof(word[1]);
		j++;
	}
	sn=j-1;	/* sentence no */
	i=1, outsn=0;
	outsn = calc_out_snum(sum_mode, sum_val, sn);
	if(debug) fprintf(stderr, "sn=%d outsn=%d\n", sn, outsn);
	while (fgets(buf, BUFSIZ, f)!=NULL) {
		ss[i].body = strdup(buf);		/* ʸ¸ */
		/*
		cptr = chasen_sparse_tostr (buf);	/* ǲ */
		/*
		words = direct_chaflt (cptr, sn);	/* ͭ */
		/*
		ss[i].wnum = chaflt_out_num;*/
		i++;
	}
	fclose (f);
	selects(ss, sn, outsn, ttl, form_mode);
}



