/* 
 *  gettfdf.c:
 *
 * Copyright (c) 1998,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 *  ƥȥեΥꥹȤ񤫤줿եɤ߹ǡ
 *  ƥեtf׻ɸϡǡ١ df dffile˽
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*#include "cmn.h"*/
#include <chainers/mrpfil.h>
#include "tfflt.h"

extern CHAFLT_OUT* direct_chaflt ();
extern char*       chasen_sparse_tostr ();

FILE   *df;
char   *dfn;
static char *pname;
int outformat;

static help()
{
	fprintf (stderr, "gettfdf ver.0.002\n");
	fprintf (stderr, "Usage: %s\n", pname);
	fprintf (stderr, "\t[-WF #] filename for output of dfdata (dffile)\n");
	fprintf (stderr, "\t[-h]    show help\n");
	fprintf (stderr, "\t[-TW]   change output format 'word tf' to 'tf word'\n");
	fprintf (stderr, " < textfilelist\n");
	exit(1);
}

void optchk (argc, argv)
    int   argc;
    char *argv[];
{
	pname = argv[0];
	dfn = "dffile";
	argc--, argv++;
	outformat=0;

	while (argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-h")) {
			help();
		} else if (!strcmp(argv[0], "-WF")) {
			argc--, argv++;
			dfn = argv[0];
		} else if (!strcmp(argv[0], "-TW")) {
			outformat=1;
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
		}
		argc--, argv++;
	}
}

int main (argc , argv)
    int    argc;
    char *argv[];
{
	int i, sn, sw, id, entry, allmrp;
	char record[BUFSIZ], *cptr, fn[200];
	CHAFLT_OUT *words;
	struct hash_entry *hashtab[5000];
	int    hashsize;
	FILE *f;

	hashsize=5000;
	optchk(argc, argv);

	if ((df=fopen(dfn, "w"))==NULL) {
		perror("cannot open");
		exit(1);
	}
	chasen_preparation (pname);
	sn = id = 1;
	entry = 0;
	init_hash_f (hashtab, hashsize);
	while (fgets(record, BUFSIZ, stdin) != NULL) {
		sscanf(record, "%s\n", fn);
		if ((f=fopen(fn, "r"))==NULL) {
			perror("fopen");
			exit(1);
		}
		while (fgets(record, BUFSIZ, f)!=NULL) {
			cptr =  chasen_sparse_tostr (record);
			words = direct_chaflt (cptr, sn, &allmrp, 0, 0, NULL);
			entry+= tffilter (words, hashtab, hashsize);
			chaflt_out_init();
		}
		init_hash (hashtab, hashsize, 0, outformat);
		printf ("EOF\n");
		fclose(f);
		id++;
		sn=1;
		number_of_words = 0;
		chaflt_out_num = 0;
		entry = 0;
	}
	fprintf (df, "N %d\n", id-1);
	init_hash (hashtab, hashsize, 1, outformat, df);
	fclose(df);
}
